package terrain;

/*******************************************
 * HeightField
 * date: 2004-05-02
 * author: Kristian Lunde
 * Based on HeightField by Fredrik Danielsen.
 ******************************************/

import java.io.*;

public class HeightField {

	private int size;
	private float[][][] area;
	
	/**
	 * Constructor
	 * @param float[][][] matrix - set the heightfield matrix.
	 */
	public HeightField(float[][][] matrix){
		this.area = matrix;	
		size = area.length;
	}
	
	/**
	 * setHeightField
	 * @param float[][][] matrix - set the heightfield matrix.
	 */
	public void setHeightField(float[][][] matrix){ 
		area = matrix; 
		size = area.length;
	}

	/**
	 * getSize
	 * @return int - return the size of the matrix.
	 */
	public int getSize(){ return this.size; }
	
	/**
	 * getHeightField
	 * @return float[][][] - return the heightfield.
	 */
	public float[][][] getHeightField(){ return area; }
	
	/**
	 * getLength
	 * @param float x - is the x coordinate of the length to be retrieved.
	 * @param float y - is the y coordinate of the length to be retrieved.
	 * @return float - return the length.
	 */
	public float getLength(int x, int y){ return area[x][y][0]; }
	
	/**
	 * getWidth
	 * @param float x - is the x coordinate of the width to be retrieved.
	 * @param float y - is the y coordinate of the width to be retrieved.
	 * @return float - return the width.
	 */
	public float getWidth(int x, int y){ return area[x][y][1]; }
	
	/**
	 * @param float x - is the x coordinate of the height to be retrieved.
	 * @param float y - is the y coordinate of the height to be retrieved.
	 * @return float - return the heightvalue of the x and y position.
	 */
	public float getHeight(int x, int y){ return area[x][y][2]; }
}