package terrain;

import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;

/******************************************************
 * KeyManager
 * date: 2004-05-16
 * author: Kristian Lunde
 * This class manipulate the heightfield in the terrainCanvas.
 *****************************************************/

public class KeyManager implements KeyListener {

	private TerrainCanvas can;

	/**
	 * Constructor
	 * @param TerrainCanvas can - a instance of the TerrainCanvas created in the TerrainViewer.
	 */
	public KeyManager(TerrainCanvas can){ this.can = can;}
	
	/**
	 * keyPressed
	 * @param KeyEvent k
	 * Move the heightfield based on which of the arrow buttons that are clicked.
	 */
	public void keyPressed(KeyEvent k){
		if(k.getKeyCode() == k.VK_UP){
			if(can.getPosX() <= 0) return;
			
			float x = can.getPosX();
			can.setPosX(x = x  - 1.0f);
			can.repaint();
		}
		else if(k.getKeyCode() == k.VK_DOWN){
			if(can.getPosX() >= 70) return;
			
			float x = can.getPosX();
			can.setPosX(x = x  + 1.0f);
			can.repaint();
		}
	}

	public void keyReleased(KeyEvent k){}
	public void keyTyped(KeyEvent k){}
}