package terrain;

import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseEvent;
import java.awt.Dimension;

/***********************************************
 * MouseManager
 * date: 2004-05-20
 * author: Kristian Lunde
 * This class is used to listen to mouseevents in the TerrainCanvas. It moves the heightfield when the mouse is dragged.
 **********************************************/

public class MouseManager implements MouseListener, MouseMotionListener {

	private TerrainCanvas can;

	/**
	 * Constructor 
	 * @param TerrainCanvas can - is a instance of the terrainCanvas object.
	 */
	public MouseManager(TerrainCanvas can){ this.can = can; }
	
	/**
	 * mouseDragged
	 * @param MouseEvent e.
	 * This method react on mousedragged events, and move the heightfield in the direction of the mouse.
	 */
  public void mouseDragged(MouseEvent e){
  		
  		//Retrieve the x and y coordinate from the mouse.
  		int x = e.getX();
  		int y = e.getY();
  		Dimension dim = e.getComponent().getSize();
  		int width = dim.width;
  		int height = dim.height;
  		
  		can.setDeltaZ((90.0f * ((float)(x - can.getLastX()) / (float)width)));
  		can.setDeltaX((90.0f * ((float)(y - can.getLastZ()) / (float)height)));

			float rot_x = can.getRotX();
  		float rot_z = can.getRotZ();
  		
  		can.setLastX(x);
  		can.setLastZ(y);
  		
  		can.setRotZ(rot_z += can.getDeltaZ());
  		can.setRotX(rot_x += can.getDeltaX());

			can.repaint();	
  }
  
  /* These metods are not used.*/
  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){}
  public void mouseMoved(MouseEvent e){}
  public void mouseClicked(MouseEvent e){}
  public void mouseReleased(MouseEvent e){}
  public void mousePressed(MouseEvent e){}
}

