package terrain;

import java.io.*;
import java.util.StringTokenizer;

/**********************************
 * TerrainLoader
 * date: 2004-05-24
 * author: Kristian Lunde
 * Load a .ter file into a float[][][] array.
 *********************************/

public class TerrainLoader {
	
	private String filename;
	private BufferedReader infile;
	private float[][][] matrix;
	private int size;
	
	/* Constructor */
	public TerrainLoader(){ filename = ""; }
	
	/**
	 * Constructor
	 * @param String filename - is the filename and the path of the file to load.
	 */
	public TerrainLoader(String filename){ open(filename); }
	
	/**
 	 * setFilename
 	 * @param String filename - set the filename to parameter filename.
 	 */	
	public void setFilename(String filename){ this.filename = filename; }
	
	/**
	 * getFilename
	 * @return the filename.
	 */
	public String getFilename(){ return this.filename; }
	
	/**
	 * open
	 * @param String filename - the filename to load.
	 * This method load a .ter file into a 3 dimensional matrix.
	 */
	public void open(String filename){
		try{
			infile = new BufferedReader(new FileReader(filename));
			
			String line = infile.readLine();
			size = Integer.parseInt(line);
			
			matrix = new float[size][size][3];
			line = infile.readLine();
			int i = 0;
			while(line != null){
				StringTokenizer token = new StringTokenizer(line, "|");
				int x = Integer.parseInt(token.nextToken()); 
				int y = Integer.parseInt(token.nextToken());
				int n = 0;
				while(token.hasMoreTokens()){
					matrix[x][y][n] = Float.parseFloat(token.nextToken());
					
					n++;
				}
				line = infile.readLine();
				i++;
			}
		}
		catch(IOException ie){ ie.printStackTrace(); }
	}
	
	/**
	 * getTerrain
	 * @return float[][][] - return the matrix that is loaded from a .ter file.
	 */
	public float[][][] getTerrain(){ return matrix; }
}