package terrain.filter;

/**************************************************
 * SIMPLE HIGHPASS FILTER
 * date: 2004-05-15
 * author: Kristian Lunde
 * This class is used to smooth a heightfield using a highpassfilter, where the matrix keeps the high values and alter the low values.
 *************************************************/

public class HighpassFilter extends Filter {
	
	/**
	 * Constructor
	 * @param float[][][] matrix - is the matrix that should be smoothed.
	 * @param float frequency - values lower than this value will be changed in the smoothing algorithm.
	 */
	public HighpassFilter(float[][][] matrix, float frequency){ 
		super(matrix); 
		setParameter(frequency);
		
		filter_name = "Highpass filter";
	}
	
	/**
	 * smooth
	 * smooth the matrix.
	 */
	public void smooth(){
		for(int x = 0; x < getMatrixSize(); x++){
			for(int y = 0; y < getMatrixSize(); y++){
				if(matrix[x][y][2] < getParameter())
					matrix[x][y][2] = getParameter();
			}
		}
	}
}