package terrain.filter;

/******************************************
 * LowpassFilter
 * date: 2004-05-18
 * author: Kristian Lunde
 * This class is used to smooth a heightfield using a lowpassfilter.
 *****************************************/

public class LowpassFilter extends Filter {

	/**
	 * Constructor
	 * @param float[][][] matrix - is the matrix to smooth.
	 * @param float frequency - is the values that the filter should correct.
	 */
	public LowpassFilter(float[][][] matrix, float frequency){
		super(matrix);
		setParameter(frequency);
		filter_name = "Lowpass filter";
	}
	
	/**
	 * smooth
	 * This metohod run the smooth algorithm on the matrix.
	 */
	public void smooth(){
		for(int x = 0; x < getMatrixSize(); x++){
			for(int y = 0; y < getMatrixSize(); y++){
				if(matrix[x][y][2] > getParameter())
					matrix[x][y][2] = getParameter(); 
			}
		}
	}
}